Package org.gradle.tooling.provider.model

# Interface ParameterizedToolingModelBuilder<T>

Type Parameters:
  `T` - The type of parameter used by this model builder.

All Superinterfaces:
  `ToolingModelBuilder`

@Incubating public interface ParameterizedToolingModelBuilder<T> extends ToolingModelBuilder
A `ToolingModelBuilder` which can be parametrized by the client.

The parameter type `T` does not need to implement the interface defined in the client side, but it does need to have the same structure. The Tooling API will create a view from the client side parameter type to the one defined in this model builder, and deal automatically with missing methods in order to allow evolution of the models.

All classes implementing this interface should also implement methods from `ToolingModelBuilder`, which will be used to determine if a model can be built by the current builder and to generate the model in case no parameter is passed from the client. The parameter type should be bound to the model type.

Since:
  4.4
See Also:
  - `ToolingModelBuilder`

## Method Summary

Modifier and Type
Method
Description
`Object`
`buildAll(String modelName, T parameter, Project project)`
Creates the model of the given type for the given project using the given parameter.
`Class<T>`
`getParameterType()`
Returns the expected type of the parameter.

### Methods inherited from interface org.gradle.tooling.provider.model.ToolingModelBuilder

`buildAll, canBuild`

## Method Details

### getParameterType

Class<T> getParameterType()
Returns the expected type of the parameter. It should be an interface with only getters and setters.

Returns:
  The type of the parameter.

### buildAll

Object buildAll(String modelName, T parameter, Project project)
Creates the model of the given type for the given project using the given parameter.

Parameters:
  `modelName` - The model name, usually the same as the name of the Java interface used by the client.
  `parameter` - The parameter received from the client.
  `project` - The project to create the model for.
Returns:
  The model.